//----------------------------------------------------------------------------------
// aviutl GPU TCYtB^
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <xmmintrin.h>

#include <tchar.h>
#include <strsafe.h>

#include <new>

#include <d3d9.h>
#include <d3dx9.h>
#include <dxerr.h>

#include "filter.h"
#include "prof.h"
#include "weight_reader.h"
#include "gpufilter.h"
#include "ddbox.h"

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
GpuFilter *g_pGpuFilter = NULL;
bool g_chg_param = true;
bool g_need_realloc = true;

//ptH[}Xp
#ifdef PROFILE_GPU
CProf* g_pProf = NULL;
bool g_flush = true;
#endif

//---------------------------------------------------------------------
// static func
//---------------------------------------------------------------------
static BOOL set_new_size(FILTER *fp);
static BOOL set_window_title(FILTER *fp);
static BOOL load_weight_files(FILTER *fp);
static BOOL open_weight_file(FILTER *fp);
static BOOL save_weight_files(FILTER *fp);
static BOOL set_3state(HWND hwnd);

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 4
enum { T_X, T_Y, T_RAD, T_MOD };
enum { C_PARA, C_FLUSH, C_U16 };

// UNICODErh邽ߏςɂȂĂ܂iDXTrace()Ȃ߁j
LPSTR track_name[TRACK_N] = { "X", "Y",  "R", "MODE" };
int track_default[TRACK_N] = { 640, 480, 3, 0 };
int track_s[TRACK_N] = { 32, 32, 1, 0 };
int track_e[TRACK_N] = { 2048, 2048, 1, 2 };

#ifndef PROFILE_GPU
LPSTR check_name[] = { "CPU/GPU" };
int check_default[] = { 1 };
#else
LPSTR check_name[] = { "CPU/GPU", "AChԂɂȂ܂ő҂", "U16ɋ" };
int check_default[] = { 1, 1, 0 };
#endif

FILTER_DLL filter = {
	FILTER_FLAG_EX_INFORMATION | FILTER_FLAG_NO_INIT_DATA,
	0, 0,
#ifdef PROFILE_GPU
	(TCHAR*)"GPU Resize(Prof)",
#else
	(TCHAR*)"GPU Resize",
#endif
	TRACK_N, (TCHAR**)track_name, track_default, track_s, track_e,
	ARRAYSIZE(check_name), (TCHAR**)check_name, check_default,
	func_proc,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL,
	NULL, 0,
	(TCHAR*)"gpu_resize by N099, ver0.9",
	NULL, NULL,
	NULL, NULL, NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	SetMemDbg();
	return &filter;
}

//---------------------------------------------------------------------
// ɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_init(FILTER *fp)
{
	//GpuFilter
	g_pGpuFilter = new(std::nothrow) GpuFilter;
	if(NULL == g_pGpuFilter){
		return FALSE;
	}

	//foCXIp
	int dev = fp->exfunc->ini_load_int(fp, "dev", 0);

	//FfoCX̍쐬s
	if(!g_pGpuFilter->Init(fp->hwnd, fp->dll_hinst, dev)){
		SAFE_DELETE(g_pGpuFilter);
		return FALSE;
	}

#ifdef PROFILE_GPU
	//vt@CpNX
	g_pProf = new(std::nothrow) CProf(fp);
#endif

	//d݃t@C̃[h
	load_weight_files(fp);

    //őTCY擾
    SYS_INFO si = { 0, };
    if(!fp->exfunc->get_sys_info(NULL, &si)){
        return FALSE;
    }else{
        track_s[T_X] = si.min_w;
        track_s[T_Y] = si.min_h;
		track_e[T_X] = min(si.max_w, g_pGpuFilter->GetMaxWidth());
		track_e[T_Y] = min(si.max_h, g_pGpuFilter->GetMaxHeight());
		track_e[T_MOD] = g_pGpuFilter->GetWeightNum() - 1;
		track_e[T_RAD] = g_pGpuFilter->GetMaxRadius();
		set_window_title(fp);
        fp->exfunc->filter_window_update(fp);
    }

	return TRUE;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit(FILTER *fp)
{
#ifdef PROFILE_GPU
	SAFE_DELETE(g_pProf);
#endif

	save_weight_files(fp);
	SAFE_DELETE(g_pGpuFilter);

	return TRUE;
}


//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc(FILTER *fp, FILTER_PROC_INFO *fpip)
{
	static int n;
	bool need_reset = false;

	CountEnt(GPU_RSZ);

	if(!g_pGpuFilter) return FALSE;

	if(TRUE != fp->exfunc->set_ycp_filtering_cache_size(
		fp, fpip->max_w, fpip->max_h, 2, NULL))
	{
		return FALSE;
	}

#ifdef PROFILE_GPU
	//GPȔI҂H
	g_flush = fp->check[C_FLUSH] ? true : false;
#endif
	
	CountEnt(CACHE);

	//t[̉摜擾
	PIXEL_YC *pyc = fp->exfunc->get_ycp_filtering_cache_ex(
			fp, fpip->editp, fpip->frame, &fpip->w, &fpip->h);
	if(pyc == NULL) return FALSE;

	CountLea(CACHE);
#if 1
	//TCYύXȂꍇ͒PɃRs[̂
	if(fpip->w == fp->track[T_X] && fpip->h == fp->track[T_Y]){
		PIXEL_YC *dst = fpip->ycp_edit; 
		for(int i=0; i<fpip->h; ++i){
			CopyMemory(dst, pyc, fpip->w * sizeof(PIXEL_YC));
			dst += fpip->max_w;
			pyc += fpip->max_w;
		}

		CountLea(GPU_RSZ);
		PrintCount();

		return TRUE;
	}
#endif
	//TCYύX̃`FbN
	if(g_pGpuFilter->IsSizeChanged(fpip->w, fpip->h, fp->track[T_X], fp->track[T_Y])){
		g_need_realloc = true;
	}

	//foCX̏Ԃ`FbN
	if(!g_pGpuFilter->TestDeviceState(&need_reset)) return FALSE;

	//foCXZbgKv
	if(need_reset){
		//Kvȏꍇ̂݃\[XĊm
		if(!g_pGpuFilter->ResetDevice(!g_need_realloc)) return FALSE;

		//p[^Đݒ肪Kv
		g_chg_param = true;
	}

	//p[^ύXꂽꍇ
	if(g_need_realloc){
		CountEnt(INIT);
		g_pGpuFilter->ReleaseResources();
#ifdef PROFILE_GPU
		g_pGpuFilter->AllocResources(fpip->w, fpip->h,
			fp->track[T_X], fp->track[T_Y], fpip->max_w, fp->check[C_U16]);
#else
		g_pGpuFilter->AllocResources(fpip->w, fpip->h,
			fp->track[T_X], fp->track[T_Y], fpip->max_w);
#endif
		g_pGpuFilter->SetParams(fp->track[T_RAD], fp->track[T_MOD]);
		CountLea(INIT);

		g_need_realloc = false;
		g_chg_param = false;
	}else if(g_chg_param){
		g_pGpuFilter->SetParams(fp->track[T_RAD], fp->track[T_MOD]);
		g_chg_param = false;
	}

	//f[^GPUɓ]
	if(!g_pGpuFilter->PutImage(pyc, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}

	//GPUŏ
	n = fpip->frame - n;
	if(!fp->check[C_PARA]){
		//
		if(!g_pGpuFilter->ProcImage()) return FALSE;
	}else{
		//񓯊
		if(!g_pGpuFilter->ProcImageAsync()) return FALSE;

		//t[LbV
		if(n){
			CountEnt(CACHE);
			fp->exfunc->get_ycp_filtering_cache_ex(
				fp, fpip->editp, fpip->frame + n, NULL, NULL);
			CountLea(CACHE);
		}
		n = fpip->frame;
	}

	//o̓f[^o
	if(!g_pGpuFilter->GetImage(fpip->ycp_edit, fp->exfunc->exec_multi_thread_func)){
		return FALSE;
	}

	//TCYZbg
	fpip->w = fp->track[T_X];
	fpip->h = fp->track[T_Y];

	CountLea(GPU_RSZ);
	PrintCount();

	return TRUE;
}

//---------------------------------------------------------------------
// ݒύXɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_update(FILTER *fp, int status)
{
	if(g_pGpuFilter){
		g_chg_param = true;
		set_window_title(fp);

		int r = g_pGpuFilter->GetMaxRadius(fp->track[T_MOD]);
		if(fp->track_e[T_RAD] != r){
#if 0 //p[^͈͓ɃZbg
			fp->track[T_RAD] = min(r, fp->track[T_RAD]);
#endif
			fp->track_e[T_RAD] = r;
			fp->exfunc->filter_window_update(fp);
		}

#ifdef PROFILE_GPU
		if(g_pGpuFilter->GetPixelFormat() != 
			g_pGpuFilter->PixelFormatFromIndex(fp->check[C_U16]))
		{
			g_need_realloc = true;
		}
#endif
	}

	return TRUE;
}

//---------------------------------------------------------------------
// ݒEBhEɃEBhEbZ[WɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_WndProc(HWND h, UINT m, WPARAM w, LPARAM l, void *e, FILTER *fp)
{
	switch(m){
		case WM_COMMAND:
			switch(HIWORD(w)){
				case BN_CLICKED:
					if(LOWORD(w) == IDC_SETSIZE){
						return set_new_size(fp);
					}
			}
			break;
		case WM_FILTER_CHANGE_ACTIVE: //tB^̗L/ύXꂽɑ܂
			if(g_pGpuFilter && !fp->exfunc->is_filter_active(fp)){
				g_pGpuFilter->ReleaseResources();
				g_need_realloc = true;
			}
			break;
		case WM_FILTER_INIT:
			// set_3state(h);
			return ddbox_init(h, fp, check_name[ARRAYSIZE(check_name)-1]);
		case WM_FILTER_EXIT:
			return ddbox_exit(h, fp);
		case WM_MBUTTONDOWN:
			return open_weight_file(fp);
		case WM_KEYDOWN:
			if(g_pGpuFilter && w == 'O'){
				SHORT st = GetKeyState(VK_CONTROL);
				if(HIWORD(st) & 0x1){
					return open_weight_file(fp);
				}
			}
			break;
		case MSG_GPUFLT_ERR:
			if(g_pGpuFilter){
				g_pGpuFilter->ShowMessageBoxAsync((TCHAR*)l);
			}
		default:
			break;
	}

	return FALSE;
}

//------------------------------------------------------------------------
// Xg{bNXŎw肳ꂽTCY擾ăZbg
//------------------------------------------------------------------------
BOOL set_new_size(FILTER *fp)
{
    POINT pt;

    if(ddbox_get_size(&pt)){
        //擾łꍇɃTCYZbg
        fp->track[T_X] = min(max(fp->track_s[T_X], pt.x), fp->track_e[T_X]);
        fp->track[T_Y] = min(max(fp->track_s[T_Y], pt.y), fp->track_e[T_Y]);
        return fp->exfunc->filter_window_update(fp);
    }else{
        return FALSE;
    }
}

//------------------------------------------------------------------------
// p̏d݂̖O\
//------------------------------------------------------------------------
BOOL set_window_title(FILTER *fp)
{
	if(g_pGpuFilter){
		char buf[256];
		StringCbPrintfA(buf, sizeof(buf), "%s (%s)", (char*)filter.name,
			g_pGpuFilter->GetWeightName(fp->track[T_MOD]));
		SetWindowTextA(fp->hwnd, buf);
	}
	return TRUE;
}

//------------------------------------------------------------------------
// d݃t@CiniɃt@Cۑ
//------------------------------------------------------------------------
#define WF_LIST_MAX 5
BOOL load_weight_files(FILTER *fp)
{
	if(g_pGpuFilter){
		char buf[64],name[MAX_PATH];
		for(int i=0; i<WF_LIST_MAX; ++i){
			StringCbPrintfA(buf, sizeof(buf), "wf_%02d", i);
			BOOL ret = fp->exfunc->ini_load_str(fp, buf, name, "");
			if(ret == TRUE && strlen(name) > 0){
				g_pGpuFilter->AppendExtWeight(name);
			}else{
				break; //A镔̂݃[h
			}
		}
	}
	return TRUE;
}

BOOL open_weight_file(FILTER *fp)
{
	if(g_pGpuFilter){
		char name[MAX_PATH];
		if(fp->exfunc->dlg_get_load_name(name,
			"weight files (*.grw)\0*.grw\0ALL (*.*)\0*.*\0",
			"gpu_resize.grw"))
		{
			if(g_pGpuFilter->AppendExtWeight(name)){
				fp->track_e[T_MOD] = g_pGpuFilter->GetWeightNum() - 1;
				return fp->exfunc->filter_window_update(fp);
			}
		}
	}

	return FALSE;
}

BOOL save_weight_files(FILTER *fp)
{
	if(g_pGpuFilter){
		char buf[64];
		const std::vector<std::string> name
			= g_pGpuFilter->GetExtWeightFileNames();
		unsigned int i = (name.size() > WF_LIST_MAX)
			? (name.size() - WF_LIST_MAX) : 0;
		for( ; i<name.size(); ++i){
			StringCbPrintfA(buf, sizeof(buf), "wf_%02d", i);
			fp->exfunc->ini_save_str(fp, buf, const_cast<char*>(name[i].c_str()));
		}
		if(i < WF_LIST_MAX){ //sentinel
			StringCbPrintfA(buf, sizeof(buf), "wf_%02d", i);
			fp->exfunc->ini_save_str(fp, buf, "");
		}
	}
	return TRUE;
}

//------------------------------------------------------------------------
// `FbN{bNX3stateɂ
//------------------------------------------------------------------------
BOOL set_3state(HWND hwnd)
{
	HWND bt = FindWindowExA(hwnd, NULL, "BUTTON", check_name[C_PARA]);
	if(bt == NULL) return FALSE;

	LONG_PTR sty = GetWindowLongPtr(hwnd, GWL_STYLE);
	if(!sty) return FALSE;
	
	return SetWindowLongPtr(hwnd, GWL_STYLE, sty | BS_AUTO3STATE);
}

//ptH[}Xp
#ifdef PROFILE_GPU
CProf::CProf(void* p)
{
	//create debug window
	FILTER* fp = static_cast<FILTER*>(p);
	m_debugWnd = CreateWindow(TEXT("EDIT"), TEXT("Debug GPU_RSZ"),
		WS_VISIBLE | WS_POPUPWINDOW | WS_CAPTION | ES_MULTILINE | ES_READONLY,
		CW_USEDEFAULT, 0,
		180, 282,
		fp->hwnd, NULL, fp->dll_hinst, NULL);
	if(m_debugWnd){
		SendMessage(m_debugWnd, WM_SETFONT, 
			(WPARAM)GetStockObject(OEM_FIXED_FONT), (LPARAM)TRUE);
	}

	InitializeCriticalSection(&m_cs);

	//set tags
	ZeroMemory(m_PCnt, sizeof(m_PCnt));
	m_PCnt[INIT].tag     = TEXT("Init   ");
	m_PCnt[CACHE].tag    = TEXT("Cache  ");
	m_PCnt[PUT_GPU].tag  = TEXT("PutGpu ");
	m_PCnt[PROC_GPU].tag = TEXT("ProcGPU");
	m_PCnt[WB_GPU].tag   = TEXT("WbGpu  ");
	m_PCnt[CPY_RES].tag  = TEXT("CopyRes");
	m_PCnt[GPU_RSZ].tag  = TEXT("GPU_RSZ");
}

CProf::~CProf()
{
	DeleteCriticalSection(&m_cs);
	if(m_debugWnd) DestroyWindow(m_debugWnd);
}

void CProf::CountEnt(EProf e)
{
	if(m_PCnt[e].valid1st){
		QueryPerformanceCounter(&m_PCnt[e].c[2]);
	}else{
		QueryPerformanceCounter(&m_PCnt[e].c[0]);
	}
}

void CProf::CountLea(EProf e)
{
	if(g_flush){
		g_pGpuFilter->WaitForIdle();
	}

	if(m_PCnt[e].valid1st){
		QueryPerformanceCounter(&m_PCnt[e].c[3]);
	}else{
		QueryPerformanceCounter(&m_PCnt[e].c[1]);
	}

	EnterCriticalSection(&m_cs);
	m_PCnt[e].valid1st = !m_PCnt[e].valid1st;
	LeaveCriticalSection(&m_cs);
}

void CProf::Print()
{
	TCHAR buf[512];
	TCHAR buf0[64];
	const TCHAR *fmt = TEXT("?");
	double rQPF;
	int h,w;

	_mm_empty();

	if(NULL == m_debugWnd) return;
	if(g_pGpuFilter){
		h = g_pGpuFilter->GetHeight();
		w = g_pGpuFilter->GetWidth();
		fmt = g_pGpuFilter->GetPixelFormatStr();
	}else{
		h = w = 0;
	}

	//get PerformanceCounter frequency
	LARGE_INTEGER ticFreq = {0,0};
	QueryPerformanceFrequency(&ticFreq);
	if(ticFreq.QuadPart > 0){
		rQPF = 1.0 / (double)ticFreq.QuadPart;
	}else{
		rQPF = 1.0;
	}
#if 0
	StringCchPrintf(buf, 512,
		TEXT("Size   :%dx%d(%s)\r\nQPF  :%.5E\r\n"), w,h, fmt, (double)ticFreq.QuadPart);
#else
	StringCchPrintf(buf, 512, TEXT("Size   :%dx%d(%s)\r\n"), w,h, fmt);
#endif
	for(int i=0; i<NUM_EP; ++i){
		LONGLONG diff;
		
		EnterCriticalSection(&m_cs);
		if(m_PCnt[i].valid1st){
			diff = m_PCnt[i].c[1].QuadPart - m_PCnt[i].c[0].QuadPart;
			m_PCnt[i].c[1].QuadPart = m_PCnt[i].c[0].QuadPart = 0;
		}else{
			diff = m_PCnt[i].c[3].QuadPart - m_PCnt[i].c[2].QuadPart;
			m_PCnt[i].c[3].QuadPart = m_PCnt[i].c[2].QuadPart = 0;
		}
		LeaveCriticalSection(&m_cs);

		if(diff > 0){
			StringCchPrintf(buf0, 64, TEXT("%s:%.5E\r\n"), m_PCnt[i].tag, diff*rQPF);
			StringCbCat(buf, sizeof(buf), buf0);
		}
	}

	SendMessage(m_debugWnd, WM_SETTEXT, 0, (LPARAM)buf);  
}

void CountEnt(EProf e)
{
	if(g_pProf) g_pProf->CountEnt(e);
}

void CountLea(EProf e)
{
	if(g_pProf) g_pProf->CountLea(e);
}

void PrintCount()
{
	if(g_pProf) g_pProf->Print();
}
#endif

#ifdef _DEBUG
void SetMemDbg()
{
	int tmpFlag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG);
	tmpFlag |= _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF;
	_CrtSetDbgFlag( tmpFlag );
}
#endif
