//----------------------------------------------------------------------------
// GPU TCYtB^
// Copyright (c) 2008 N099
//----------------------------------------------------------------------------
#include "weight_size.h"

//----------------------------------------------------------------------------
// eNX`ƃTv
//----------------------------------------------------------------------------
Texture2D txWgt;
sampler samWgt =
sampler_state
{
    Texture = <txWgt>;
    AddressU = CLAMP;
    AddressV = CLAMP;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;
};

Texture2D txSrc;
sampler samSrc =
sampler_state
{
    Texture = <txSrc>;
    AddressU = MIRROR;
    AddressV = MIRROR;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;
};

#define DEF_STATE \
		AddressU[0] = CLAMP;\
		AddressV[0] = CLAMP;\
		MinFilter[0] = LINEAR;\
		MagFilter[0] = LINEAR;\
		MipFilter[0] = NONE;\
		\
		AddressU[1] = MIRROR;\
		AddressV[1] = MIRROR;\
		MinFilter[1] = POINT;\
		MagFilter[1] = POINT;\
		MipFilter[1] = NONE;\
		\
		ZEnable = FALSE;

//----------------------------------------------------------------------------
// tB^W
//----------------------------------------------------------------------------
int iRadius;
int iRep[2];
float2 fRszSrc;
float2 fMinRt;

//----------------------------------------------------------------------------
// g厞̏d݂tFb` pos:[0.0, 1.0)Ƃ
//----------------------------------------------------------------------------
float2 GetMagWeight(float pos, float offs)
{
	//ItZbgLȔ͈͂ɊZ
	pos = pos * (WIDTH_WEIGHT_F - 1.0f) + 0.5f; //pos:[0.5, 255.5)
	pos /= WIDTH_WEIGHT_F;
	offs = (offs + 0.5f)/ HEIGHT_WEIGHT_F;
	
	return tex2D(samWgt, float2(pos, offs)).rg;
}

//----------------------------------------------------------------------------
// k̏d݂tFb`
//----------------------------------------------------------------------------
float2 GetMinWeight(float2 offs)
{
	float2 pos = frac(offs);
	offs -= pos;

	//ItZbgLȔ͈͂ɊZ
	pos = pos * (WIDTH_WEIGHT_F - 1.0f) + 0.5f; //pos:[0.5, 255.5)
	pos /= WIDTH_WEIGHT_F;
	offs = (offs + 0.5f)/ HEIGHT_WEIGHT_F;
	
	float4 t = { pos, offs };
	return float2(tex2D(samWgt, t.xz).r, tex2D(samWgt, t.yw).r);
}

//-----------------------------------------------------------------------------
// Pixel Shader: MagnifyHorizPS
// Desc: ̊g
//-----------------------------------------------------------------------------
float4 MagnifyHorizPS(float4 tex : TEXCOORD0) : COLOR0
{
	float3 sum = { 0.0f, 0.0f, 0.0f };
	float wsum = 0.0f;
	float wpos = frac(tex.z);
	float ppos0 = tex.z - wpos + 0.5f;
	float ppos1 = tex.z - wpos + 1.5f;
	
	for(int i=0; i<iRadius; ++i){
		float2 t0 = { (ppos0 - i) * fRszSrc.x, tex.y };
		float2 t1 = { (ppos1 + i) * fRszSrc.x, tex.y };
		float2 w = GetMagWeight(wpos, i);
		
		sum += w.x * tex2D(samSrc, t0).rgb;
		sum += w.y * tex2D(samSrc, t1).rgb;
		wsum += w.x + w.y;
	}
	
	return float4(sum/wsum, 0.0f);
}

//-----------------------------------------------------------------------------
// Pixel Shader: MinifyHorizPS
// Desc: ̏k
//-----------------------------------------------------------------------------
float4 MinifyHorizPS(float4 tex : TEXCOORD0) : COLOR0
{
	float3 sum = { 0.0f, 0.0f, 0.0f };
	float wsum = 0.0f;
	float2 fpos = { frac(tex.z), 1.0f - frac(tex.z) };
	float tpos = tex.z + 0.5f;

	for(int i=0; i<iRep[0]; ++i){
		float2 wpos = fpos + i;
		float2 t0 = { (tpos - wpos.x) * fRszSrc.x, tex.y };
		float2 t1 = { (tpos + wpos.y) * fRszSrc.x, tex.y };
		float2 w = GetMinWeight(wpos * fMinRt.x);
		
		sum += w.x * tex2D(samSrc, t0).rgb;
		sum += w.y * tex2D(samSrc, t1).rgb;
		wsum += w.x + w.y;
	}
	
	return float4(sum/wsum, 0.0f);
}

//-----------------------------------------------------------------------------
// Pixel Shader: MagnifyVertPS
// Desc: ̊g
//-----------------------------------------------------------------------------
float4 MagnifyVertPS(float4 tex : TEXCOORD0) : COLOR0
{
	float3 sum = { 0.0f, 0.0f, 0.0f };
	float wsum = 0.0f;
	float wpos = frac(tex.w);
	float ppos0 = tex.w - wpos + 0.5f;
	float ppos1 = tex.w - wpos + 1.5f;
	
	for(int i=0; i<iRadius; ++i){
		float2 t0 = { tex.x, (ppos0 - i) * fRszSrc.y };
		float2 t1 = { tex.x, (ppos1 + i) * fRszSrc.y };
		float2 w = GetMagWeight(wpos, i);
		
		sum += w.x * tex2D(samSrc, t0).rgb;
		sum += w.y * tex2D(samSrc, t1).rgb;
		wsum += w.x + w.y;
	}
	
	return float4(sum/wsum, 0.0f);
}

//-----------------------------------------------------------------------------
// Pixel Shader: MinifyVertPS
// Desc: ̏k
//-----------------------------------------------------------------------------
float4 MinifyVertPS(float4 tex : TEXCOORD0) : COLOR0
{
	float3 sum = { 0.0f, 0.0f, 0.0f };
	float wsum = 0.0f;
	float2 fpos = { frac(tex.w), 1.0f - frac(tex.w) };
	float tpos = tex.w + 0.5f;
	
	for(int i=0; i<iRep[1]; ++i){
		float2 wpos = fpos + i;
		float2 t0 = { tex.x, (tpos - wpos.x) * fRszSrc.y };
		float2 t1 = { tex.x, (tpos + wpos.y) * fRszSrc.y };
		float2 w = GetMinWeight(wpos * fMinRt.y);
		
		sum += w.x * tex2D(samSrc, t0).rgb;
		sum += w.y * tex2D(samSrc, t1).rgb;
		wsum += w.x + w.y;
	}
	
	return float4(sum/wsum, 0.0f);
}

//-----------------------------------------------------------------------------
// Technique: ResizeGPU
// Desc: GPUTCYtB^
//-----------------------------------------------------------------------------
technique ResizeGPU
{
	pass p0
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 MinifyHorizPS();
		DEF_STATE
	}
	pass p1
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 MagnifyHorizPS();
		DEF_STATE
	}
	pass p2
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 MinifyVertPS();
		DEF_STATE
	}
	pass p3
	{
		VertexShader = null;
		PixelShader = compile ps_3_0 MagnifyVertPS();
		DEF_STATE
	}
}
