//----------------------------------------------------------------------------------
// dݓǂݍ݃NX
// Copyright (c) 2008  N099
//----------------------------------------------------------------------------------
#pragma once
#include <string>
#include <vector>
#include <map>

class BaseWeightReader {
public:
	virtual ~BaseWeightReader();
	virtual const char* GetFileName() const { return NULL; }
	virtual int GetWeight(int r, std::vector<float> &g) const = 0;
	virtual int GetRadiusNum() const = 0;
	virtual bool operator==(const char*) const { return false; }

	const char* GetName() const { return _name.c_str(); }
	static bool LoadWeight(const char *name, BaseWeightReader* &wr);

protected:
	BaseWeightReader(const char *name);
	std::string _name;
};

class WeightReader : public BaseWeightReader {
public:
	WeightReader();
	~WeightReader();
	const char* GetFileName() const { return _file_name.c_str(); }
	int GetWeight(int r, std::vector<float> &g) const;
	int GetRadiusNum() const { return _radius.size(); }
	bool operator==(const char*name) const { return _file_name == name; }
	bool LoadFile(const char *name);

private:
	WeightReader(const WeightReader& wr);
	WeightReader& operator=(const WeightReader& wr);

	std::string _file_name;
	std::vector< std::map<int, float> > _weight;
	std::vector<int> _radius;

	void AppendWeight(char *buf);
	static const int _set_max = 32;
};
